#include  <Uefi.h>
#include  <Library/UefiLib.h>
#include  <Library/ShellCEntryLib.h>

#include <Protocol/UnicodeCollation.h>

extern EFI_BOOT_SERVICES         *gBS;
extern EFI_SYSTEM_TABLE			 *gST;
extern EFI_RUNTIME_SERVICES 	 *gRT;

EFI_UNICODE_COLLATION_PROTOCOL   *mUnicodeCollation = NULL;

VOID
EFIAPI
lowercase(
  IN OUT CHAR16	*Str
  )
{
	UINT32	i;
	CHAR8	*p;
	p=(CHAR8 *)Str;
	for (i=0;i<StrSize(Str);i++) {
		//Print(L"%d ",*p);
		if ((*p>='A')&&(*p<='Z')) {
			*p=*p+32;
		}
		p++;
	}
	
}	
int
EFIAPI
main (
  IN int Argc,
  IN CHAR16 **Argv
  )
{
  EFI_STATUS	Status;
  CHAR16		*s1=L"Www.Lab-z.Com 1243";
  CHAR16		*s2=L"Www.Lab-z.Com 1243";
  
  if (mUnicodeCollation == NULL) {
		Status = gBS->LocateProtocol(
			&gEfiUnicodeCollation2ProtocolGuid,
			NULL,
			(VOID**)&mUnicodeCollation);

		if (EFI_ERROR(Status)) {
			Print(L"Can't find UnicodeCollation2 Protocol!\n"); 
			return EFI_SUCCESS;
		}
  }

  mUnicodeCollation->StrUpr(
    mUnicodeCollation,
    s1);
  Print(L"%s\n",s1);
  
  lowercase(s2);
  Print(L"%s\n",s2);  
  return EFI_SUCCESS;
}

